﻿<template>
    <section class="profile">
        <div class="member-info">
            <div>
                <h2>{{ t('pages.profile.title') }} {{member.firstName}} {{member.lastName}}</h2>
                <p><span>Email : </span>{{member.email}}</p>
            </div>
            <img v-if="member.avatar" class="round-img" :src="urlImg" />
        </div>
        <div class="profile-btns">
            <button class="btn" @click="showUpdateForm">{{ t('pages.profile.editProfileButton') }}</button>
            <button class="btn" @click="resetPssword">{{ t('pages.profile.editPasswordButton') }}</button>
            <button class="btn" @click="deleteUser">{{ t('pages.profile.deleteButton') }}</button>
        </div>
    </section>

    <Card v-show="isVisible" class="member-form-card">
        <MemberForm :member="member" @formSubmit="handleSubmit" />
    </Card>
    <Card v-show="isEditPassword" class="member-form-card">
        <EditPasswordForm @formSubmit="handlePassswordSubmit" />
    </Card>
</template>

<script lang="ts" setup>
    import { useI18n } from "vue3-i18n";
    import { useMemberStore } from "@/stores/memberStore";
    import { useMemberService } from "@/inversify.config";
    import { notifyError, notifySuccess } from "@/notify";
    import { ref } from "vue";
    import { Member } from "@/types/entities";
    import { IUpdateMemberRequest } from "@/types/requests/updateMemberRequest";
    import { IUpdatePasswordRequest } from "../../types/requests/updatePasswordRequest";
    import Card from "@/components/layout/Card.vue";
    import MemberForm from "@/components/members/MemberForm.vue"
    import EditPasswordForm from "@/components/members/EditPasswordForm.vue"

    const allMembers = ref<Member[]>([]);
    const { t } = useI18n()
    const memberStore = useMemberStore()
    const member = memberStore.member
    const memberService = useMemberService()
    let isVisible = ref(false)
    let isEditPassword = ref(false)
    const urlImg = member.avatar

    function showUpdateForm() {
        isVisible.value = !isVisible.value;
        isEditPassword.value = false;
    }

    function resetPssword() {
        isEditPassword.value = !isEditPassword.value;
        isVisible.value = false;
    }

    async function handleSubmit(member: Member) {
        let succeededOrNotResponse = await memberService.updateMember(member as IUpdateMemberRequest)
        if (succeededOrNotResponse && succeededOrNotResponse.succeeded) {
            notifySuccess(t('validation.member.edit.success'))
            setTimeout(() => {
                window.location.replace("/Authentication/Logout/");
            }, 1500);
        } else {
            let errorMessages = succeededOrNotResponse.getErrorMessages('validation.member.edit');
            if (errorMessages.length == 0)
                notifyError(t('validation.member.edit.errorOccured'))
            else
                notifyError(errorMessages[0])
        }
    }

    async function handlePassswordSubmit(password: string, oldPassword: string) {
        const request: IUpdatePasswordRequest = {
            id: member.id,
            password: password,
            oldPassword: oldPassword
        }
        let succeededOrNotResponse = await memberService.updateMemberPassword(request as IUpdatePasswordRequest)
        if (succeededOrNotResponse && succeededOrNotResponse.succeeded) {
            notifySuccess(t('validation.member.edit.success'))
            setTimeout(() => {
                window.location.replace("/Authentication/Logout/");
            }, 1500);
        } else {
            let errorMessages = succeededOrNotResponse.getErrorMessages('validation.member.edit');
            if (errorMessages.length == 0)
                notifyError(t('validation.member.edit.errorOccured'))
            else
                notifyError(errorMessages[0])
        }
    }

    async function deleteUser() {
        const memberStore = useMemberStore()
        const member = memberStore.member

        let confirmDelete = confirm(t("validation.member.delete.confirmation"));
        if (!confirmDelete)
            return;

        let response = await memberService.deleteMember(member.id)
        if (response.succeeded) {
            allMembers.value = allMembers.value.filter(x => x.id !== member.id)
            notifySuccess(t('validation.member.delete.success'))
            setTimeout(() => {
                window.location.replace("/Authentication/Logout/")
            }, 2500);

        } else {
            let errorMessages = response.getErrorMessages('validation.member.delete',
                'validation.member.delete.errorOccured')
            notifyError(errorMessages[0])
        }
    }
</script>
